       IDENTIFICATION DIVISION.
       PROGRAM-ID.    SAMPLE.
       DATE-WRITTEN.  JANUARY 1993.
       DATE-COMPILED.
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER. IBM-3090.
       OBJECT-COMPUTER. IBM-3090.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
            SELECT LOAD-FILE ASSIGN TO LOADFILE
                   FILE STATUS IS WF-LOADFILE-STATUS.

            SELECT AUDIT-FILE ASSIGN TO AUDTFILE
                   FILE STATUS IS WF-AUDTFILE-STATUS.

            SELECT REPORT-FILE ASSIGN TO PIN2RPT1
                   FILE STATUS IS WF-REPORT-STATUS.

           EJECT
       DATA DIVISION.
       FILE SECTION.
       FD  LOAD-FILE
           BLOCK  CONTAINS 0 RECORDS.
       01  LOAD-RECORD                PIC X(133).
       FD  AUDIT-FILE
           BLOCK  CONTAINS 0 RECORDS.
       01  AUDIT-RECORD               PIC X(133).
       FD  REPORT-FILE
           BLOCK CONTAINS 0 RECORDS.
       01  REPORT-RECORD              PIC X(133).
       EJECT
       WORKING-STORAGE SECTION.

      ******************************************************************
      *     CONSTANTS
      ******************************************************************

       01  WC-CONSTANTS.
           05  FILLER                  PIC X(9)
                           VALUE       "CONSTANTS".
           05  WC-BATCH-HDR            PIC X(15)
                           VALUE "BATCHPENS01PINC".
           05  WC-AUDIT-TRAIL          PIC X(19)
                           VALUE "PAYROLL AUDIT TRAIL".
           05  WC-PINC                 PIC X(4)
                           VALUE            "PINC".
           05  WC-INPUT                PIC X(10)
                           VALUE           "INPUT".
           05  WC-VALIDATION           PIC X(10)
                           VALUE           "VALIDATION".
           05  WC-HDR-CONST-LOAD       PIC X(17)
                           VALUE           "TRANSACTION LOAD)".
           05  WC-HDR-CONST-AUDIT      PIC X(16)
                           VALUE           "AUDIT TRAIL)".
           05  WC-REC-CONST1           PIC X(50) VALUE
              " TOTAL VALUE OF RECORDS REJECTED ON VALIDATION".
           05  WC-REC-CONST2           PIC X(50) VALUE
              " TOTAL VALUE OF RECORDS REJECTED ON INPUT     ".
           05  WC-REC-CONST3           PIC X(50) VALUE
              " TOTAL VALUE OF RECORDS ACCEPTED BY PAYROLL".
           05  WC-REC-CONST4           PIC X(50) VALUE
              " GRAND TOTAL OF RECORDS PROCESSED BY PAYROLL   ".

      ******************************************************************
      *     ERROR MESSAGES
      ******************************************************************

       01  WE-MESSAGES.
           05  FILLER                  PIC X(8) VALUE
                                       "MESSAGES".
           05  WE-ERROR-MESSAGES.
               10  WE-ERR1                 PIC X(32)
                         VALUE "NO BATCH HEADER ON LOAD FILE".
               10  WE-ERR2                 PIC X(32)
                         VALUE "NO 'H' RECORDS FOLLOWING HEADER".
               10  WE-ERR3                 PIC X(32)
                         VALUE "NO BATCH HEADER ON AUDIT FILE".
               10  WE-ERR4                 PIC X(32)
                         VALUE "NO 'H'+'PINC' RECORD FOUND  ".
               10  WE-OPEN-REPORT-ERROR    PIC X(32)
                         VALUE "REPORT FILE OPEN ERROR      ".
               10  WE-WRITE-REPORT-ERROR   PIC X(32)
                         VALUE "REPORT FILE WRITE ERROR     ".
               10  WE-CLOSE-REPORT-ERROR   PIC X(32)
                         VALUE "REPORT FILE CLOSE ERROR     ".
               10  WE-OPEN-LOAD-ERROR      PIC X(32)
                         VALUE "LOAD FILE OPEN ERROR      ".
               10  WE-READ-LOAD-ERROR      PIC X(32)
                         VALUE "LOAD FILE READ ERROR     ".
               10  WE-CLOSE-LOAD-ERROR     PIC X(32)
                         VALUE "LOAD FILE CLOSE ERROR     ".
               10  WE-OPEN-AUDIT-ERROR     PIC X(32)
                         VALUE "AUDIT FILE OPEN ERROR      ".
               10  WE-READ-AUDIT-ERROR     PIC X(32)
                         VALUE "AUDIT FILE WRITE ERROR     ".
               10  WE-CLOSE-AUDIT-ERROR    PIC X(32)
                         VALUE "AUDIT FILE CLOSE ERROR     ".
       EJECT

      ******************************************************************
      *     FLAGS
      ******************************************************************

       01  WF-FLAGS.
           05  FILLER                  PIC X(5) VALUE
                                       "FLAGS".
           05  WF-LOADFILE-STATUS      PIC XX.
           05  WF-AUDTFILE-STATUS      PIC XX.
           05  WF-REPORT-STATUS        PIC XX.
           05  WF-LOAD-EOF             PIC 9.
           05  WF-AUDIT-EOF            PIC 9.

      ******************************************************************
      *     GENERAL
      ******************************************************************

       01  WG-GENERAL.
           05  FILLER                    PIC X(7) VALUE
                                                  "GENERAL".
           05  WG-LOAD-HEADER.
               10  FILLER                PIC X.
               10  WG-L-HDR-TEXT         PIC X(15).
               10  FILLER                PIC x(117).
           05  WG-LOAD-RECORD REDEFINES WG-LOAD-HEADER.
               10  FILLER                PIC X.
               10  WG-L-IND              PIC X.
               10  FILLER                PIC X.
               10  WG-L-PAYNUMBER        PIC X(7).
               10  FILLER                PIC X(3).
               10  WG-L-HEDNUM           PIC X(3).
               10  FILLER                PIC X(6).
               10  WG-L-VALUE            PIC 9(5)V99.
               10  FILLER                PIC X(52).
               10  WG-L-ERROR-MSG        PIC X(12).
               10  FILLER                PIC X(40).
           05  WG-AUDIT-HEADER REDEFINES WG-LOAD-HEADER.
               10  FILLER                PIC X(61).
               10  WG-A-HDR-TEXT         PIC X(19).
               10  FILLER                PIC X(53).
           05  WG-AUDIT-DETAIL REDEFINES WG-AUDIT-HEADER.
               10  FILLER                PIC X.
               10  WG-A-IND              PIC X.
               10  FILLER                PIC XX.
               10  WG-A-PAYNUMBER        PIC X(7).
               10  FILLER                PIC X(4).
               10  WG-A-HEDNUM           PIC X(3).
               10  FILLER                PIC X(30).
               10  WG-A-VALUE            PIC 9(5)V99.
               10  FILLER                PIC X(30).
               10  WG-A-ERROR-MSG        PIC X(34).
               10  FILLER                PIC X(2).
               10  WG-A-PINC-IND         PIC X(4).
               10  FILLER                PIC X(8).
      *
           05  WG-PAGE-NUMBER            PIC S9(4) COMP.
           05  WG-ADVANCE-NUMBER         PIC S9(4) COMP.
           05  WG-LINE-COUNT             PIC S9(4) COMP.
      *
           05  WG-LOAD-ERR-COUNT         PIC S9(4) COMP.
           05  WG-AUDIT-ERR-COUNT        PIC S9(4) COMP.
           05  WG-AUDIT-ACC-COUNT        PIC S9(4) COMP.
           05  WG-TOTAL-COUNT            PIC S9(4) COMP.
      *
           05  WG-LOAD-ERR-VALUE         PIC S9(9)V99 COMP.
           05  WG-AUDIT-ERR-VALUE        PIC S9(9)V99 COMP.
           05  WG-AUDIT-ACC-VALUE        PIC S9(9)V99 COMP.
           05  WG-TOTAL-VALUE            PIC S9(9)V99 COMP.
      *
           05  WG-REC-COUNT              PIC S9(4) COMP.
           05  WG-LAST-PAYNUMBER         PIC X(7).
           05  WG-FILE-IND               PIC X.
           05  WG-RECON-FLAG             PIC X VALUE SPACE.
      *
           05  WG-DATE.
               10  WG-DATE-YY            PIC XX.
               10  WG-DATE-MM            PIC XX.
               10  WG-DATE-DD            PIC XX.


      ******************************************************************
      *    REPORT LAYOUTS
      ******************************************************************

       01  WR-PAGE-HEADER-1.
           05  FILLER                   PIC X(2) VALUE SPACES.
           05  FILLER                   PIC X(46) VALUE
             "PROGRAM PIN2    ".
           05  FILLER                   PIC X(28) VALUE
             "- SAMPLE CO.".
           05  FILLER                   PIC X(10) VALUE SPACES.
           05  WR-RUN-DATE.
              10  WR-PRINT-PREP-DD    PIC XX.
              10  FILLER              PIC X VALUE "/".
              10  WR-PRINT-PREP-MM    PIC XX.
              10  FILLER              PIC X VALUE "/".
              10  WR-PRINT-PREP-YY    PIC XX.
           05  FILLER                 PIC X(12) VALUE SPACES.
           05  FILLER                 PIC X(5) VALUE
             "PAGE ".
           05  WR-PAGE-NUMBER         PIC ZZ9.

       01  WR-PAGE-HEADER-2.
           05  FILLER                   PIC X(44) VALUE SPACES.
           05  FILLER                   PIC X(36)
               VALUE "PENSIONS INCREASES CONTROL REPORT".
       01  WR-PAGE-HEADER-3.
           05  FILLER                   PIC X(32) VALUE SPACES.
           05  FILLER                   PIC X(35)
               VALUE "RECORDS REJECTED ON INPUT(REPORTED ".
           05  FILLER                   PIC X(10)
               VALUE "BY CYBORG ".
           05  WR-HDR-3-VARIABLE        PIC X(17).
       01  WR-PAGE-HEADER-4.
           05  FILLER                   PIC X(17) VALUE SPACES.
           05  FILLER                   PIC X(14)
               VALUE "PAYROLL NUMBER".
           05  FILLER                   PIC X(10) VALUE SPACES.
           05  FILLER                   PIC X(3)
               VALUE "HED".
           05  FILLER                   PIC X(10) VALUE SPACES.
           05  FILLER                   PIC X(5)
               VALUE "VALUE".
           05  FILLER                   PIC X(18) VALUE SPACES.
           05  FILLER                   PIC X(20)
               VALUE "REJECTION MESSAGE".
       01  WR-ERROR-LINE.
           05  FILLER                   PIC X(24) VALUE SPACES.
           05  WR-ERROR-MESSAGE         PIC X(50).
       01  WR-REPORT-NOERROR-LINE.
           05  FILLER                   PIC X(45) VALUE SPACES.
           05  FILLER                   PIC X(33)
               VALUE "NO RECORDS HAVE BEEN REJECTED ON ".
           05  WR-NOERR-VARIABLE        PIC X(10).
       01  WR-REPORT-DASH-LINE.
           05  FILLER                   PIC X(45) VALUE SPACES.
           05  FILLER                   PIC X(45)
               VALUE "---------------------------------------".
       01  WR-PAGE-HEADER-6.
           05  FILLER                   PIC X(20)
                          VALUE " RECONCILIATION".
       01  WR-PAGE-HEADER-7.
           05  FILLER                   PIC X(20)
                          VALUE " --------------".
       01  WR-PAGE-HEADER-8.
           05  FILLER                   PIC X(50) VALUE SPACES.
           05  FILLER                   PIC X(6)
               VALUE "NUMBER".
           05  FILLER                   PIC X(28) VALUE SPACES.
           05  FILLER                   PIC X(20)
               VALUE "VALUE".
       01  WR-PAGE-HEADER-9.
           05  FILLER                   PIC X(50) VALUE SPACES.
           05  FILLER                   PIC X(6)
               VALUE "------".
           05  FILLER                   PIC X(28) VALUE SPACES.
           05  FILLER                   PIC X(20)
               VALUE "-----".
       01  WR-RECON-LINE.
           05  WR-RECON-TEXT            PIC X(51).
           05  WR-RECON-COUNT           PIC Z(4)9.
           05  FILLER                   PIC X(20) VALUE SPACES.
           05  WR-RECON-VALUE           PIC (9)9.99.
       01  WR-RECON-DASH.
           05  FILLER                   PIC X(51) VALUE SPACES.
           05  FILLER                   PIC X(5)  VALUE "-----".
           05  FILLER                   PIC X(20) VALUE SPACES.
           05  FILLER                   PIC X(13)
                         VALUE "-------------".
       01  WR-REPORT-END.
           05  FILLER                   PIC X(45) VALUE SPACES.
           05  FILLER                   PIC X(60)
               VALUE "END OF PENSION INCREASE CONTROL REPORT".
       01  WR-SPACE-LINE.
           05  FILLER                   PIC X(132) VALUE SPACES.
       01  WR-PRINT-LINE.
               10  FILLER                  PIC X(19) VALUE SPACES.
               10  WR-PRINT-PAYROLL        PIC 9(7).
               10  FILLER                  PIC X(15) VALUE SPACES.
               10  WR-HEDNUM               PIC X(3).
               10  FILLER                  PIC X(6)  VALUE SPACES.
               10  WR-PRINT-VALUE          PIC (5)9.99.
               10  FILLER                  PIC X(12) VALUE SPACES.
               10  WR-PRINT-ERROR          PIC X(40).

       EJECT

       LINKAGE SECTION.
      *****************
       01  LA-PARAM-RECORD.
           05  LA-PARAM-LENGTH         PIC XX.
      ******************************************************************
      *     TRACE SWITCH
      ******************************************************************
           05  LA-TRACE-SWITCH         PIC X.

           EJECT

      ******************************************************************
      ******************************************************************

       PROCEDURE DIVISION USING LA-PARAM-RECORD.
       A00-CONTROL SECTION.
       A10-START.
           IF LA-TRACE-SWITCH = "Y"
              DISPLAY "A10"
           END-IF.
      *                                          **********************
      *                                          Initialise work areas
      *                                          **********************
           PERFORM AA00-INITIALISE.
      *                                          **********************
      *                                          Process LOAD file
      *                                          **********************
           PERFORM AB00-PROCESS-MAIN.
      *                                          **********************
      *                                          Process AUDIT file
      *                                          **********************
           PERFORM ABB00-MAIN-AUDIT UNTIL (WF-AUDIT-EOF = 1)
      *                                          **********************
      *                                          Write reconcilliation
      *                                          report
      *                                          **********************
           PERFORM AC00-TERMINATE.
       A99-EXIT.
           EXIT.
           EJECT
       AA00-INITIALISE SECTION.
       AA10-START.
      *
           IF LA-TRACE-SWITCH = "Y"
              DISPLAY "AA10"
           END-IF.
      *
           INITIALIZE WG-GENERAL.
           MOVE 0                   TO WF-LOAD-EOF.
           MOVE 0                   TO WF-AUDIT-EOF.

           PERFORM YA00-OPEN-REPORT-FILE.

      *                                          **********************
      *                                          Set Heading Dates
      *                                          **********************
           ACCEPT WG-DATE FROM DATE.
           MOVE WG-DATE-YY          TO WR-PRINT-PREP-YY.
           MOVE WG-DATE-MM          TO WR-PRINT-PREP-MM.
           MOVE WG-DATE-DD          TO WR-PRINT-PREP-DD.
           MOVE ZERO                TO WG-PAGE-NUMBER.
      *                                          ***********************
      *                                          Write headings for
      *                                             page 1
      *                                          ***********************
           MOVE WC-HDR-CONST-LOAD TO WR-HDR-3-VARIABLE.
           PERFORM XA00-EJECT-PAGE.
       AA99-EXIT.
           EXIT.
           EJECT
       AB00-PROCESS-MAIN.
       AB10-START.
      *
           IF LA-TRACE-SWITCH = "Y"
              DISPLAY "AB10"
           END-IF.
      *
      *                                          **********************
      *                                          Process LOAD file
      *                                          **********************
           PERFORM ABA00-MAIN-LOAD UNTIL (WF-LOAD-EOF = 1).
      *                                          **********************
      *                                          Process AUDIT file
      *                                          **********************
           PERFORM ABB00-MAIN-AUDIT UNTIL (WF-AUDIT-EOF = 1).
      *
       AB99-EXIT.
           EXIT.
           EJECT
       ABA00-MAIN-LOAD SECTION.
       ABA10-START.
      *
           IF LA-TRACE-SWITCH = "Y"
              DISPLAY "ABA10"
           END-IF.
      *
           PERFORM YB00-OPEN-LOAD-FILE.
           MOVE "L" TO WG-FILE-IND.
      *                                      ***************************
      *                                      Locate batch header
      *                                      'BATCHPENS01PINC'
      *                                      ***************************
           PERFORM ABAA00-FIND-HEADER.
      *                                      ***************************
      *                                      Process each of the
      *                                      'H' records until either
      *                                       there are no more or EOF
      *                                      ***************************
           PERFORM ABAB00-PROCESS-LOAD-REC
               UNTIL WF-LOAD-EOF = 1.
      *                                      ***************************
      *                                      If no error records printed
      *                                      from LOAD input file, print
      *                                      a message on the report
      *                                      ***************************
           IF WG-LOAD-ERR-COUNT = 0
               MOVE WC-VALIDATION TO WR-NOERR-VARIABLE
               MOVE WR-REPORT-NOERROR-LINE TO REPORT-RECORD
               PERFORM XC00-WRITE-LINE
           END-IF.
      *                                      ***************************
      *                                      End of LOAD file processing
      *                                           close file
      *                                      ***************************
           PERFORM YD00-CLOSE-LOAD-FILE.
      *
       ABA99-EXIT.
           EXIT.
           EJECT
       ABAA00-FIND-HEADER SECTION.
       ABAA10-START.
      *
           IF LA-TRACE-SWITCH = "Y"
              DISPLAY "ABAA10"
           END-IF.
      *
      *                                        *************************
      *                                         Locate batch header
      *                                         'BATCHPENS01PINC'
      *                                        *************************
           PERFORM YC00-READ-LOAD WITH TEST AFTER UNTIL
                       ( WG-L-HDR-TEXT = WC-BATCH-HDR OR
                         WF-LOAD-EOF   = 1)
      *                                        *************************
      *                                         Header not found
      *                                        *************************
           IF WF-LOAD-EOF = 1
               MOVE WE-ERR1 TO WR-ERROR-MESSAGE
               PERFORM XD00-WRITE-ERROR-LINE
               PERFORM ZZ00-FATAL-END
           END-IF.
      *                                        *************************
      *                                        Read next record
      *                                        *************************
           PERFORM YC00-READ-LOAD.
      *                                        *************************
      *                                        Record not type "H"
      *                                        *************************
           IF WG-L-IND NOT = "H"
               MOVE WE-ERR2 TO WR-ERROR-MESSAGE
               PERFORM XD00-WRITE-ERROR-LINE
               PERFORM ZZ00-FATAL-END
           END-IF.

       ABAA99-EXIT.
           EXIT.
           EJECT
       ABAB00-PROCESS-LOAD-REC SECTION.
       ABAB10-START.
           IF LA-TRACE-SWITCH = "Y"
              DISPLAY "ABAB10"
           END-IF.

      *                                        *************************
      *                                        Process each "H" record
      *                                        *************************

           IF WG-L-ERROR-MSG NOT = SPACES
              PERFORM XE00-PRINT-REPORT
              ADD 1 TO WG-LOAD-ERR-COUNT
              ADD WG-L-VALUE  TO WG-LOAD-ERR-VALUE
           END-IF.
      *                                        *************************
      *                                        Fetch next record type H
      *                                         which has an error
      *                                        *************************
           MOVE WG-L-PAYNUMBER TO WG-LAST-PAYNUMBER.
           PERFORM YC00-READ-LOAD WITH TEST AFTER UNTIL
                   (( WG-L-IND            = "H"    AND
                      WG-L-PAYNUMBER IS NUMERIC    AND
                      WG-L-PAYNUMBER  NOT < WG-LAST-PAYNUMBER AND
                      WG-L-HEDNUM    IS NUMERIC    AND
                      WG-L-ERROR-MSG  NOT = SPACES    )  OR
                      WF-LOAD-EOF     NOT = 0            OR
                      WG-L-IND        NOT = "H")
      *                                        *************************
      *                                        Non H record read
      *                                        *************************
           IF WF-LOAD-EOF = 0
              AND WG-L-IND NOT = "H"
              MOVE 0 TO WG-REC-COUNT
      *                                        *************************
      *                                        Locate next H record or
      *                                         end of file
      *                                        *************************
           PERFORM YC00-READ-LOAD WITH TEST AFTER UNTIL
                   (( WG-L-IND            = "H"    AND
                      WG-L-PAYNUMBER IS NUMERIC    AND
                      WG-L-PAYNUMBER  NOT < WG-LAST-PAYNUMBER AND
                      WG-L-HEDNUM    IS NUMERIC    AND
                      WG-L-VALUE     IS NUMERIC      ) OR
                      WF-LOAD-EOF         = 1  )
      *                                        *************************
      *                                        If more than a header
      *                                         (6 records),end
      *                                        *************************
              IF WG-REC-COUNT > 6
                MOVE 1 TO WF-LOAD-EOF
              END-IF
           END-IF.

       ABAB99-EXIT.
           EXIT.
           EJECT
       ABB00-MAIN-AUDIT SECTION.
       ABB10-START.

      *                                        *************************
      *                                        Set up and write page
      *                                          headings
      *                                        *************************
           MOVE SPACES TO WG-LAST-PAYNUMBER.
           MOVE WC-HDR-CONST-AUDIT TO WR-HDR-3-VARIABLE.
           PERFORM XA00-EJECT-PAGE.

           PERFORM YF00-OPEN-AUDIT-FILE.
           MOVE "A" TO WG-FILE-IND.
      *                                        *************************
      *                                         Locate batch header
      *                                         'PAYROLL AUDIT TRAIL '
      *                                        *************************
           PERFORM ABBA00-FIND-HEADER.
      *                                        *************************
      *                                          Process each of the
      *                                         'H' records until either
      *                                         there are no more or EOF
      *                                        *************************
           PERFORM ABBB00-PROCESS-AUDIT-REC
               UNTIL WF-AUDIT-EOF = 1.
      *                                      ***************************
      *                                      If no error records printed
      *                                      from AUDIT input file, prin
      *                                      a message on the report
      *                                      ***************************
           IF WG-AUDIT-ERR-COUNT = 0
               MOVE WC-INPUT TO WR-NOERR-VARIABLE
               MOVE WR-REPORT-NOERROR-LINE TO REPORT-RECORD
               PERFORM XC00-WRITE-LINE
           END-IF.
      *                                      ***************************
      *                                      End of AUDIT file processin
      *                                           close file
      *                                      ***************************
           PERFORM YH00-CLOSE-AUDIT-FILE.
      *
       ABB99-EXIT.
           EXIT.
           EJECT
       ABBA00-FIND-HEADER SECTION.
       ABBA10-START.
      *
           IF LA-TRACE-SWITCH = "Y"
              DISPLAY "ABBA10"
           END-IF.
      *
      *                                        *************************
      *                                         Locate batch header
      *                                         'PAYROLL AUDIT TRAIL'
      *                                        *************************
           PERFORM YG00-READ-AUDIT WITH TEST AFTER UNTIL
                       ( WG-A-HDR-TEXT = WC-AUDIT-TRAIL OR
                         WF-AUDIT-EOF  = 1)
      *                                        *************************
      *                                         Header not found        05
      *                                        *************************
           IF WF-AUDIT-EOF = 1
               MOVE WE-ERR3 TO WR-ERROR-MESSAGE
               PERFORM XD00-WRITE-ERROR-LINE
               PERFORM ZZ00-FATAL-END
           END-IF.

      *                                        *************************
      *                                           Locate first 'PINC'
      *                                           type 'H' record
      *                                        *************************
           PERFORM YG00-READ-AUDIT WITH TEST AFTER UNTIL
                      (( WG-A-IND      = "H"           AND
                         WG-A-PINC-IND = WC-PINC)       OR
                         WF-AUDIT-EOF  = 1)
      *                                        *************************
      *                                         H / PINC not found
      *                                        *************************
           IF WF-AUDIT-EOF = 1
               MOVE WE-ERR4 TO WR-ERROR-MESSAGE
               PERFORM XD00-WRITE-ERROR-LINE
               PERFORM ZZ00-FATAL-END
           END-IF.

       ABBA99-EXIT.
           EXIT.
           EJECT
       ABBB00-PROCESS-AUDIT-REC SECTION.
       ABBB10-START.
      *
           IF LA-TRACE-SWITCH = "Y"
              DISPLAY "ABBB10"
           END-IF.

      *                                        *************************
      *                                        Process each "H" record
      *                                        *************************
           IF WG-A-ERROR-MSG = SPACES
              ADD 1 TO WG-AUDIT-ACC-COUNT
              ADD WG-A-VALUE  TO WG-AUDIT-ACC-VALUE
           ELSE
              PERFORM XE00-PRINT-REPORT
              ADD 1 TO WG-AUDIT-ERR-COUNT
              ADD WG-A-VALUE  TO WG-AUDIT-ERR-VALUE
           END-IF.
      *                                        *************************
      *                                        Fetch next record type H
      *                                        *************************
           MOVE WG-A-PAYNUMBER TO WG-LAST-PAYNUMBER.
           PERFORM YG00-READ-AUDIT WITH TEST AFTER UNTIL
                   (( WG-A-IND            = "H"    AND
                      WG-A-PAYNUMBER IS NUMERIC    AND
                      WG-A-PAYNUMBER  NOT < WG-LAST-PAYNUMBER AND
                      WG-A-VALUE     IS NUMERIC    AND
                      WG-A-PINC-IND       = WC-PINC)  OR
                      WF-AUDIT-EOF    NOT = 0       OR
                      WG-A-IND        NOT = "H")
      *                                        *************************
      *                                        Non H record read
      *                                        *************************
           IF WF-AUDIT-EOF = 0
              AND WG-A-IND NOT = "H"
              MOVE 0 TO WG-REC-COUNT
      *                                        *************************
      *                                        Locate next H record or
      *                                         end of file
      *                                        *************************
           PERFORM YG00-READ-AUDIT WITH TEST AFTER UNTIL
                       ( WG-A-IND         = "H"  OR
                         WF-AUDIT-EOF     = 1  )
      *                                        *************************
      *                                        If more than a header
      *                                         (6 records),end
      *                                        *************************
              IF WG-REC-COUNT > 6
                MOVE 1 TO WF-AUDIT-EOF
              END-IF
           END-IF.

       ABBB99-EXIT.
           EXIT.
           EJECT
       AC00-TERMINATE SECTION.
       AC10-START.

      *                                        *************************
      *                                        Write reconcilliation
      *                                         report
      *                                        *************************
           PERFORM ACA00-END-REPORT.
      *                                        *************************
      *                                        Close report file
      *                                         and stop run
      *                                        *************************
           PERFORM YJ00-CLOSE-REPORT-FILE.
           STOP RUN.

       AC99-EXIT.
           EXIT.
           EJECT
       ACA00-END-REPORT SECTION.
       ACA10-START.
      *                                        *************************
      *                                        Column titles not written
      *                                        in reconcilliation report
      *                                        headings
      *                                        *************************
           MOVE "R" TO WG-RECON-FLAG.
           PERFORM XA00-EJECT-PAGE.

      *                                        *************************
      *                                        Write reconcilliation
      *                                        report
      *                                        *************************
           MOVE 3              TO WG-ADVANCE-NUMBER.
           MOVE WR-PAGE-HEADER-6   TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.

           MOVE 1              TO WG-ADVANCE-NUMBER.
           MOVE WR-PAGE-HEADER-7   TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.

           MOVE WR-PAGE-HEADER-8   TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.

           MOVE WR-PAGE-HEADER-9   TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.

           MOVE SPACES             TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.

           MOVE WC-REC-CONST1      TO WR-RECON-TEXT.
           MOVE WG-LOAD-ERR-COUNT  TO WR-RECON-COUNT.
           MOVE WG-LOAD-ERR-VALUE  TO WR-RECON-VALUE.
           MOVE WR-RECON-LINE      TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.
           ADD WG-LOAD-ERR-COUNT   TO WG-TOTAL-COUNT.
           ADD WG-LOAD-ERR-VALUE   TO WG-TOTAL-VALUE.

           MOVE WC-REC-CONST2      TO WR-RECON-TEXT.
           MOVE WG-AUDIT-ERR-COUNT TO WR-RECON-COUNT.
           MOVE WG-AUDIT-ERR-VALUE TO WR-RECON-VALUE.
           MOVE WR-RECON-LINE      TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.
           ADD WG-AUDIT-ERR-COUNT  TO WG-TOTAL-COUNT.
           ADD WG-AUDIT-ERR-VALUE  TO WG-TOTAL-VALUE.

           MOVE WC-REC-CONST3      TO WR-RECON-TEXT.
           MOVE WG-AUDIT-ACC-COUNT TO WR-RECON-COUNT.
           MOVE WG-AUDIT-ACC-VALUE TO WR-RECON-VALUE.
           MOVE WR-RECON-LINE      TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.
           ADD WG-AUDIT-ACC-COUNT  TO WG-TOTAL-COUNT.
           ADD WG-AUDIT-ACC-VALUE  TO WG-TOTAL-VALUE.

           MOVE WR-RECON-DASH      TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.

           MOVE WC-REC-CONST4      TO WR-RECON-TEXT.
           MOVE WG-TOTAL-COUNT     TO WR-RECON-COUNT.
           MOVE WG-TOTAL-VALUE     TO WR-RECON-VALUE.
           MOVE WR-RECON-LINE      TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.

      *                                        *************************
      *                                        Write end of report line
      *                                        *************************
           MOVE 28 TO WG-ADVANCE-NUMBER.
           MOVE WR-REPORT-END TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.

       ACA99-EXIT.
           EXIT.
           EJECT
       XA00-EJECT-PAGE SECTION.
       XA10-START.

      *                                        *************************
      *                                        Write page headings
      *                                        *************************
           ADD  1                 TO WG-PAGE-NUMBER.
           MOVE WG-PAGE-NUMBER    TO WR-PAGE-NUMBER.

           WRITE REPORT-RECORD FROM WR-SPACE-LINE
                 AFTER ADVANCING PAGE.

           IF  WF-REPORT-STATUS NOT = "00"
               DISPLAY WE-WRITE-REPORT-ERROR
               DISPLAY "STATUS :" WF-REPORT-STATUS
               PERFORM ZZ00-FATAL-END
           END-IF.

           MOVE 1              TO WG-ADVANCE-NUMBER.
           MOVE WR-PAGE-HEADER-1   TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.

           MOVE 2                  TO WG-ADVANCE-NUMBER.

           MOVE WR-PAGE-HEADER-2   TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.

           IF WG-RECON-FLAG = " "

              MOVE 3                  TO WG-ADVANCE-NUMBER

              MOVE WR-PAGE-HEADER-3   TO REPORT-RECORD
              PERFORM XC00-WRITE-LINE

              MOVE WR-PAGE-HEADER-4   TO REPORT-RECORD
              PERFORM XC00-WRITE-LINE

           ELSE

              MOVE 7                  TO WG-ADVANCE-NUMBER

           END-IF.


           MOVE SPACES         TO REPORT-RECORD.
           PERFORM XC00-WRITE-LINE.
      *
           MOVE 10             TO WG-LINE-COUNT.
      *
           MOVE 1              TO WG-ADVANCE-NUMBER.

      *
       XA99-EXIT.
           EXIT.
           EJECT
       XB00-WRITE-REPORT-LINE SECTION.
       XB10-START.

      *                                        *************************
      *                                        Write detail line for
      *                                        rejected records
      *                                        *************************
           ADD 1                           TO WG-LINE-COUNT.
           IF WG-FILE-IND = "L"
              MOVE WG-L-PAYNUMBER          TO WR-PRINT-PAYROLL
              MOVE WG-L-HEDNUM             TO WR-HEDNUM
              MOVE WG-L-VALUE              TO WR-PRINT-VALUE
              MOVE WG-L-ERROR-MSG          TO WR-PRINT-ERROR
           ELSE
              MOVE WG-A-PAYNUMBER          TO WR-PRINT-PAYROLL
              MOVE WG-A-HEDNUM             TO WR-HEDNUM
              MOVE WG-A-VALUE              TO WR-PRINT-VALUE
              MOVE WG-A-ERROR-MSG          TO WR-PRINT-ERROR
           END-IF.

           MOVE WR-PRINT-LINE TO REPORT-RECORD.

           PERFORM XC00-WRITE-LINE.
       XB99-EXIT.
           EXIT.
           EJECT
       XC00-WRITE-LINE SECTION.
       XC10-START.

      *                                        *************************
      *                                        Write report line
      *                                        *************************
           WRITE REPORT-RECORD AFTER WG-ADVANCE-NUMBER.

           IF  WF-REPORT-STATUS NOT = "00"
               DISPLAY WE-WRITE-REPORT-ERROR
               DISPLAY "STATUS :" WF-REPORT-STATUS
               PERFORM ZZ00-FATAL-END
           END-IF.
       XC99-EXIT.
           EXIT.
           EJECT
       XD00-WRITE-ERROR-LINE SECTION.
       XD10-START.

      *                                        *************************
      *                                        Write error  line
      *                                        *************************
           MOVE WR-ERROR-LINE TO REPORT-RECORD.

           WRITE REPORT-RECORD AFTER WG-ADVANCE-NUMBER.

           IF  WF-REPORT-STATUS NOT = "00"
               DISPLAY WE-WRITE-REPORT-ERROR
               DISPLAY "STATUS :" WF-REPORT-STATUS
               PERFORM ZZ00-FATAL-END
           END-IF.
       XD99-EXIT.
           EXIT.
           EJECT
       XE00-PRINT-REPORT SECTION.
       XE10-START.

           IF (WG-PAGE-NUMBER = 0)  OR (WG-LINE-COUNT > 47)
      *                                        *************************
      *                                        Start new page and print
      *                                         headings
      *                                        *************************
               PERFORM XA00-EJECT-PAGE
           END-IF.
      *                                        *************************
      *                                        Print report line
      *                                        *************************
           PERFORM XB00-WRITE-REPORT-LINE.


       XE99-EXIT.
           EXIT.
           EJECT
       YA00-OPEN-REPORT-FILE SECTION.
       YA10-START.
      *                                        *************************
      *                                        Open report file
      *                                        *************************

           OPEN OUTPUT REPORT-FILE.

           IF  WF-REPORT-STATUS NOT = "00"
               DISPLAY WE-OPEN-REPORT-ERROR
               DISPLAY "STATUS :" WF-REPORT-STATUS
               PERFORM ZZ00-FATAL-END
           END-IF.
       YA99-EXIT.
           EXIT.
           EJECT
       YB00-OPEN-LOAD-FILE SECTION.
       YB10-START.
      *                                        *************************
      *                                        Open LOAD file
      *                                        *************************

           OPEN INPUT LOAD-FILE.

           IF  WF-LOADFILE-STATUS NOT = "00"
               DISPLAY WE-OPEN-LOAD-ERROR
               DISPLAY "STATUS :" WF-LOADFILE-STATUS
               PERFORM ZZ00-FATAL-END
           END-IF.
       YB99-EXIT.
           EXIT.
           EJECT
       YC00-READ-LOAD SECTION.
       YC10-START.

      *                                        *************************
      *                                        Read LOAD file
      *                                        *************************
           READ LOAD-FILE INTO WG-LOAD-HEADER
                AT END
                   MOVE 1 TO WF-LOAD-EOF.

           IF  WF-LOADFILE-STATUS NOT = "00" AND "10"
               DISPLAY WE-READ-LOAD-ERROR
               DISPLAY "STATUS :" WF-LOADFILE-STATUS
               PERFORM ZZ00-FATAL-END
           END-IF.
           ADD 1 TO WG-REC-COUNT.
       YC99-EXIT.
           EXIT.
           EJECT
       YD00-CLOSE-LOAD-FILE SECTION.
       YD10-START.
      *                                        *************************
      *                                        Close LOAD file
      *                                        *************************
           CLOSE LOAD-FILE

           IF  WF-LOADFILE-STATUS NOT = "00"
               DISPLAY WE-CLOSE-LOAD-ERROR
               DISPLAY "STATUS :" WF-LOADFILE-STATUS
               PERFORM ZZ00-FATAL-END
           END-IF.
       YD99-EXIT.
           EXIT.
           EJECT
       YF00-OPEN-AUDIT-FILE SECTION.
       YF10-START.
      *                                        *************************
      *                                        Open AUDIT file
      *                                        *************************
           OPEN INPUT AUDIT-FILE.

           IF  WF-AUDTFILE-STATUS NOT = "00"
               DISPLAY WE-OPEN-AUDIT-ERROR
               DISPLAY "STATUS :" WF-AUDTFILE-STATUS
               PERFORM ZZ00-FATAL-END
           END-IF.
       YF99-EXIT.
           EXIT.
           EJECT
       YG00-READ-AUDIT SECTION.
       YG10-START.

      *                                        *************************
      *                                        Read AUDIT file
      *                                        *************************
           READ AUDIT-FILE INTO WG-AUDIT-HEADER
                AT END
                   MOVE 1 TO WF-AUDIT-EOF.

           IF  WF-AUDTFILE-STATUS NOT = "00" AND "10"
               DISPLAY WE-READ-AUDIT-ERROR
               DISPLAY "STATUS :" WF-AUDTFILE-STATUS
               PERFORM ZZ00-FATAL-END
           END-IF.
           ADD 1 TO WG-REC-COUNT.
       YG99-EXIT.
           EXIT.
           EJECT
       YH00-CLOSE-AUDIT-FILE SECTION.
       YH10-START.
      *                                        *************************
      *                                        Close AUDIT file
      *                                        *************************

           CLOSE AUDIT-FILE

           IF  WF-AUDTFILE-STATUS NOT = "00"
               DISPLAY WE-CLOSE-AUDIT-ERROR
               DISPLAY "STATUS :" WF-AUDTFILE-STATUS
               PERFORM ZZ00-FATAL-END
           END-IF.
       YH99-EXIT.
           EXIT.
           EJECT
       YJ00-CLOSE-REPORT-FILE SECTION.
       YJ10-START.
      *                                        *************************
      *                                        Close REPORT file
      *                                        *************************
           CLOSE REPORT-FILE

           IF  WF-REPORT-STATUS NOT = "00"
               DISPLAY WE-CLOSE-REPORT-ERROR
               DISPLAY "STATUS :" WF-REPORT-STATUS
               PERFORM ZZ00-FATAL-END
           END-IF.
       YJ99-EXIT.
           EXIT.
           EJECT

       ZZ00-FATAL-END SECTION.
       ZZ10-START.

           STOP RUN.

       ZZ99-EXIT.
           EXIT.
           EJECT


